{-------------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: Main.pas, released 11 Mar 2001.

The Initial Developer of the Original Code is Jrgen Gntherodt.

Portions created by Jrgen Gntherodt <jguentherodt@users.sourceforge.net>
are Copyright (C) 2001-2002 Jrgen Gntherodt. All Rights Reserved.

Alternatively, the contents of this file may be used under the terms of the
GNU General Public License Version 2 or later (the "GPL"), in which case
the provisions of the GPL are applicable instead of those above.
If you wish to allow use of your version of this file only under the terms
of the GPL and not to allow others to use your version of this file
under the MPL, indicate your decision by deleting the provisions above and
replace them with the notice and other provisions required by the GPL.
If you do not delete the provisions above, a recipient may use your version
of this file under either the MPL or the GPL.

$Id: MAIN.PAS,v 1.8 2002/05/26 13:47:34 jguentherodt Exp $

You may retrieve the latest version of this file at the Open Perl IDE webpage,
located at http://open-perl-ide.sourceforge.net or http://www.lost-sunglasses.de
-------------------------------------------------------------------------------}
unit Main;

interface

uses
  Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, StdActns,
  ActnList, ToolWin, ImgList, SynEdit, Math, message_interface, clProcess,
  RequestProcessor, PerlDebugger2, ChildWin, registry, ConfigStorage,
  comObj, activeX, shlObj, shellAPI, breakpoints, elTree,
  SynEditHighlighter, SynHighlighterPerl, SynMemo, DockPanel,
  SynHighlighterMPerl, InstanceManager;

type
  TExecutionState = (ecsNone, ecsPendingCommand, ecsCompile, ecsDebug, ecsRun);

  TMainForm = class(TForm, IMessageReceiver, IDropTarget)
    OpenDialog: TOpenDialog;
    ActionList: TActionList;
    acCut: TEditCut;
    acCopy: TEditCopy;
    acPaste: TEditPaste;
    acFileNew: TAction;
    acFileSave: TAction;
    acFileExit: TAction;
    acFileOpen: TAction;
    acFileSaveAs: TAction;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowArrangeAll1: TWindowArrange;
    WindowMinimizeAll1: TWindowMinimizeAll;
    acFileClose: TWindowClose;
    WindowTileVertical1: TWindowTileVertical;
    ToolBar2: TToolBar;
    btnOpen: TToolButton;
    btnSave: TToolButton;
    ToolButton3: TToolButton;
    btnCut: TToolButton;
    btnCopy: TToolButton;
    btnPaste: TToolButton;
    btnNew: TToolButton;
    ToolButton7: TToolButton;
    btnCascade: TToolButton;
    btnTileHorizontally: TToolButton;
    btnTileVertically: TToolButton;
    ImageList1: TImageList;
    splitLeft: TSplitter;
    splitBottom: TSplitter;
    splitTop: TSplitter;
    splitRight: TSplitter;
    pnlTopDummy: TPanel;
    acRun: TAction;
    acStepOver: TAction;
    acStepInto: TAction;
    acProgramReset: TAction;
    acCompile: TAction;
    SaveDialog: TSaveDialog;
    acPreferences: TAction;
    memoDebugScriptTemplate: TMemo;
    pnlTabs: TPanel;
    pnlTabsLeft: TPanel;
    pnlTabsClient: TPanel;
    pnlTabsRight: TPanel;
    tcFiles: TTabControl;
    Label2: TLabel;
    cbxDesktop: TComboBox;
    acFind: TAction;
    acFindInFiles: TAction;
    acReplace: TAction;
    acSearchAgain: TAction;
    acIncrementalSearch: TAction;
    acGoToLineNumber: TAction;
    FindDialog: TFindDialog;
    ReplaceDialog: TReplaceDialog;
    acFileOpen2: TAction;
    acAbout: TAction;
    SynPerl: TSynPerlSyn;
    acSaveAll: TAction;
    acCloseAll: TAction;
    acPrint: TAction;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    acUndo: TAction;
    acRedo: TAction;
    acHelpContents: TAction;
    ToolButton4: TToolButton;
    btnUndo: TToolButton;
    btnRedo: TToolButton;
    ToolButton8: TToolButton;
    btnCompile: TToolButton;
    btnRun: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    btnStepOver: TToolButton;
    btnStepInto: TToolButton;
    ToolButton9: TToolButton;
    btnProgramReset: TToolButton;
    pnlSeparator: TPanel;
    StatusBar: TStatusBar;
    acHelpIndex: TAction;
    acHelpConfiguration: TAction;
    acForceScriptTermination: TAction;
    acFilePrintPreview: TAction;
    PrintDialog: TPrintDialog;
    acFilePageSetup: TAction;
    PrinterSetupDialog: TPrinterSetupDialog;
    timerRedrawHostingPageControls: TTimer;
    dpLeft: TDockPanel;
    dpRight: TDockPanel;
    dpTop: TDockPanel;
    dpBottom: TDockPanel;
    tmrHelp: TTimer;
    SynPerl2: TSynMPerlSyn;
    MainMenu: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    N9: TMenuItem;
    FileOpenItem: TMenuItem;
    N10: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    SaveAll1: TMenuItem;
    FileCloseItem: TMenuItem;
    CloseAll1: TMenuItem;
    N11: TMenuItem;
    Pagesetup1: TMenuItem;
    PrintPreview1: TMenuItem;
    Print1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    Edit1: TMenuItem;
    Undo1: TMenuItem;
    Redo1: TMenuItem;
    N12: TMenuItem;
    CutItem: TMenuItem;
    CopyItem: TMenuItem;
    PasteItem: TMenuItem;
    N5: TMenuItem;
    Preferences1: TMenuItem;
    Search1: TMenuItem;
    Find1: TMenuItem;
    acFindInFiles1: TMenuItem;
    Replace1: TMenuItem;
    SearchAgain1: TMenuItem;
    IncrementalSearch1: TMenuItem;
    N8: TMenuItem;
    GotoLineNumbers1: TMenuItem;
    Project1: TMenuItem;
    miSetActiveProject: TMenuItem;
    N2: TMenuItem;
    N7: TMenuItem;
    Compile1: TMenuItem;
    Run1: TMenuItem;
    Run2: TMenuItem;
    N3: TMenuItem;
    StepOver1: TMenuItem;
    TraceInto1: TMenuItem;
    N4: TMenuItem;
    ProgramReset1: TMenuItem;
    acForceScriptTermination1: TMenuItem;
    Window1: TMenuItem;
    Outputwindows1: TMenuItem;
    miConsole: TMenuItem;
    miErrorOutput: TMenuItem;
    N15: TMenuItem;
    miCommunicationLog: TMenuItem;
    Debugwindows1: TMenuItem;
    miBreakpoints: TMenuItem;
    miCallstack: TMenuItem;
    miVariables: TMenuItem;
    miModules: TMenuItem;
    Helpwindows1: TMenuItem;
    miHelpContents: TMenuItem;
    miHelpIndex: TMenuItem;
    N16: TMenuItem;
    miHelpViewer: TMenuItem;
    N6: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowTileItem2: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    Help1: TMenuItem;
    Contents1: TMenuItem;
    Index1: TMenuItem;
    N14: TMenuItem;
    HelpConfiguration1: TMenuItem;
    N13: TMenuItem;
    HelpAboutItem: TMenuItem;
    procedure acFileNewExecute(Sender: TObject);
    procedure acFileOpenExecute(Sender: TObject);
    procedure acFileExitExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure acStepOverExecute(Sender: TObject);
    procedure acStepIntoExecute(Sender: TObject);
    procedure acRunExecute(Sender: TObject);
    procedure acProgramResetExecute(Sender: TObject);
    procedure acFileSaveExecute(Sender: TObject);
    procedure cbxDesktopKeyPress(Sender: TObject; var Key: Char);
    procedure cbxDesktopClick(Sender: TObject);
    procedure acPreferencesExecute(Sender: TObject);
    procedure Debugwindows1Click(Sender: TObject);
    procedure miBreakpointsClick(Sender: TObject);
    procedure miCallstackClick(Sender: TObject);
    procedure miVariablesClick(Sender: TObject);
    procedure miModulesClick(Sender: TObject);
    procedure miConsoleClick(Sender: TObject);
    procedure miErrorOutputClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure acCompileExecute(Sender: TObject);
    procedure acFileSaveAsExecute(Sender: TObject);
    procedure acFileCloseExecute(Sender: TObject);
    procedure tcFilesChange(Sender: TObject);
    procedure acFindExecute(Sender: TObject);
    procedure acSearchAgainExecute(Sender: TObject);
    procedure FindDialogFind(Sender: TObject);
    procedure acReplaceExecute(Sender: TObject);
    procedure ReplaceDialogReplace(Sender: TObject);
    procedure acGoToLineNumberExecute(Sender: TObject);
    procedure acFileOpen2Execute(Sender: TObject);
    procedure acAboutExecute(Sender: TObject);
    procedure Outputwindows1Click(Sender: TObject);
    procedure acSaveAllExecute(Sender: TObject);
    procedure acUndoExecute(Sender: TObject);
    procedure acRedoExecute(Sender: TObject);
    procedure acCloseAllExecute(Sender: TObject);
    procedure acHelpIndexExecute(Sender: TObject);
    procedure acHelpContentsExecute(Sender: TObject);
    procedure acHelpConfigurationExecute(Sender: TObject);
    procedure acForceScriptTerminationExecute(Sender: TObject);
    procedure acFilePrintPreviewExecute(Sender: TObject);
    procedure acPrintExecute(Sender: TObject);
    procedure acFilePageSetupExecute(Sender: TObject);
    procedure splitTopCanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure splitTopMoved(Sender: TObject);
    procedure splitLeftCanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure splitLeftMoved(Sender: TObject);
    procedure splitBottomCanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure splitBottomMoved(Sender: TObject);
    procedure splitRightCanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure splitRightMoved(Sender: TObject);
    procedure timerRedrawHostingPageControlsTimer(Sender: TObject);
    procedure dpLeftDockOver(Sender: TObject; Source: TDragDockObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure dpTopDockOver(Sender: TObject; Source: TDragDockObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure dpRightDockOver(Sender: TObject; Source: TDragDockObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure dpBottomDockOver(Sender: TObject; Source: TDragDockObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure dpLeftResize(Sender: TObject);
    procedure dpRightResize(Sender: TObject);
    procedure Helpwindows1Click(Sender: TObject);
    procedure miCommunicationLogClick(Sender: TObject);
    procedure miHelpContentsClick(Sender: TObject);
    procedure miHelpIndexClick(Sender: TObject);
    procedure miHelpViewerClick(Sender: TObject);
    procedure cbxDesktopKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure tmrHelpTimer(Sender: TObject);
  private
    { Private declarations }
    m_sActiveProjectFile: String;
    m_ws: TWindowState;
    m_bInitializing: Boolean;
    m_bIgnoreLineReport: Boolean;
    m_sLastProjectExecuted: String;
    m_bPendingFileAgeCheck: Boolean;
    m_ConfigStorage: TConfigStorage;
    m_bStdOutReplace: Boolean;
    m_bStdErrReplace: Boolean;
    m_sStdOutReplace: String;
    m_sStdErrReplace: String;
    m_bClosing: Boolean;
    m_dtDebugStartTime: TDateTime;
    m_LastActiveEditor: TMDIChild;
    function HandleDebugMessage(nMsgID: Integer; sData: String): Integer;
    function GetBreakpointCount: Integer;
    function GetFindOptions: TSynSearchOptions;
    function GetSearchAndReplaceOptions: TSynSearchOptions;
    procedure HandleGoto(Sender: TObject; var sGoto: String);
    procedure LoadPreferencesFromIni;
    procedure SavePreferencesToIni;
    function InternalExpandFileName(sFileName: String): String;
    procedure AddTextToList(sData: String; sl: TStrings; var bReplaceMode: Boolean; var sReplaceStr: String);
    procedure SetExecutionState(xs: TExecutionState);
    procedure HandleDockHandlerRefresh(Sender: TObject);
    procedure HandleSetOtherHostsAsString(Sender: TDockHandler; sValue: String);
    function HandleGetOtherHostsAsString(Sender: TDockHandler): String;
    function GetAsString: String;
    procedure SetAsString(s: String);
    procedure FastLoadFiles(slFiles: TStringList; sActiveProject: String);
  protected
    // IMessageReceiver
    function IMessageReceiver.HandleMessage = HandleDebugMessage;
    function ReceiveFromStdOut(sData: String): Integer;
    function ReceiveFromStdErr(sData: String): Integer;
    function HandleTerminate: Integer;
    procedure HandleCLEvent(Sender: TObject; sData: String; bError, bTerminate: Boolean);
    // IDropTarget
    function DragEnter(const dataObj: IDataObject; grfKeyState: Longint;
      pt: TPoint; var dwEffect: Longint): HResult; stdcall;
    function DragOver(grfKeyState: Longint; pt: TPoint;
      var dwEffect: Longint): HResult; stdcall;
    function DragLeave: HResult; stdcall;
    function Drop(const dataObj: IDataObject; grfKeyState: Longint; pt: TPoint;
      var dwEffect: Longint): HResult; stdcall;
    procedure WndProc(var Message: TMessage); override;
  public
    { Public declarations }
    m_ExecutionState: TExecutionState;
    m_ReqProc: TRequestProcessor;
    m_sIniFileName: String;
    m_sOldHintString: String;
    m_sHintValue: String;
    m_clpPerl: TCLProcess;
    m_sAppPath: String;
    m_colActiveConsoleFontColor: TColor;
    procedure ActivationFromOtherInstance;
    procedure RedrawHostingPageControls;
    function ChildFromFileName(sFileName: String): TMDIChild;
    function ShowPreferences: Boolean;
    function CreateMDIChild(const Name: string; bChangeProject: Boolean): TMDIChild;
    function ShowFile(sFileName: String; nLine: Integer; bError: Boolean; bChangeProject: Boolean; mdi: TMDIChild = nil): TMDIChild;
    procedure ShowWatches;
    procedure StartDebugging(sParams: String; bStepInto: Boolean);
    procedure SaveDesktop(sDesktopName: String);
    function LoadDesktop(sDesktopName: String): Boolean;
    procedure SaveSettings;
    procedure LoadSettings;
    procedure SaveProjectSettings;
    procedure LoadProjectSettings;
    function IsExecutable(sFileName: String): Boolean;
    function GetVisibleDockClientCount(win: TWinControl): Integer;
    procedure HandleShowHint(var HintStr: string; var CanShow: Boolean; var HintInfo: THintInfo);
    procedure HandleHint(Sender: TObject);
    procedure HandleActiveProjectClick(Sender: TObject);
    procedure ChangeProject(sNewProjectFileName: String);
    procedure UpdateProjectMenu;
    procedure SendToStdIn(s: String);
    procedure ShowError(sFileName: String; nLine: Integer);
    procedure DispatchBPChangeEvent(Sender: TObject; sFileName: String; nLine: Integer; sCondition: String; bDelete: Boolean);
    procedure SendBreakpointsToDebugger(bpl: TBreakpointList);
    function BlockingEval(sCode: String): String;
    procedure UpdateActions; 
    procedure SaveIDESetting(sSection, sEntry, sValue: String);
    property ActiveProjectFile: String Read m_sActiveProjectFile;
    property ExecutionState: TExecutionState Read m_ExecutionState Write SetExecutionState;
    property ConfigStorage: TConfigStorage Read m_ConfigStorage;
    property LastActiveEditor: TMDIChild Read m_LastActiveEditor Write m_LastActiveEditor;
    property AsString: String Read GetAsString Write SetAsString;
  end;

var
  MainForm: TMainForm;


// procedure DebugLog(s: String);

implementation

{$R *.DFM}

uses
  f_About, f_Variables, f_Console, f_CommunicationLog, f_Modules,
  f_Breakpoints, f_CallStack, f_ErrorOutput, f_Preferences, f_GoTo,
  f_Help, f_HelpIndex, f_HelpContents;


(*
procedure DebugLog(s: String);
var
  fs: TFileStream;
begin
  s := Format('%s: %s'#13#10, [DateTimeToStr(Now), s]);
  try
    fs := TFileStream.Create('DebugLog.txt', fmOpenReadWrite);
  except
    fs := TFileStream.Create('DebugLog.txt', fmCreate);
  end;
  fs.Seek(0, soFromEnd);
  fs.Write(s[1], Length(s));
  fs.Free;
end;
*)


function InternalGetLongPathName(APath:String):String;
var
  i : Integer;
  h : THandle;
  Data : TWin32FindData;
  IsBackSlash : Boolean;
begin
  APath:=ExpandFileName(APath);
  i:=Pos('\',APath);
  Result:=Copy(APath,1,i);
  Delete(APath,1,i);
  repeat
    i:=Pos('\',APath);
    IsBackSlash:=i>0;
    if Not IsBackSlash then
      i:=Length(APath)+1;
    h:=FindFirstFile(PChar(Result+Copy(APath,1,i-1)),Data);
    if h<>INVALID_HANDLE_VALUE then begin
      try
        Result:=Result+Data.cFileName;
        if IsBackSlash then 
          Result:=Result+'\';
      finally
        Windows.FindClose(h);
      end;
    end
    else begin
      Result:=Result+APath;
      Exit;
    end;
    Delete(APath,1,i);
  until Length(APath)=0;
end;



procedure TMainForm.ActivationFromOtherInstance;
var
  sl: TStringList;
  i: Integer;
  sFileName: String;
begin
  Application.Restore;
  Application.BringToFront;
  sl := TStringList.Create;
  sl.CommaText := rcvStr;
  if sl.Count > 0 then sl.Delete(0);
  for i := 0 to sl.Count - 1 do begin
    sFileName := InternalGetLongPathName(sl[i]);
    if FileExists(sFileName) then begin
      ShowFile(sFileName, -1, False, True);
    end;
  end;
  sl.Free;
end;


function TMainForm.GetAsString: String;
var
  sl: TStringList;
begin
  sl := TStringList.Create;
  sl.Values['Left'] := IntToStr(Left);
  sl.Values['Top'] := IntToStr(Top);
  sl.Values['Width'] := IntToStr(Width);
  sl.Values['Height'] := IntToStr(Height);
  sl.Values['WindowState'] := IntToStr(ord(WindowState));
  Result := sl.CommaText;
  sl.Free;
end;


procedure TMainForm.SetAsString(s: String);
var
  sl: TStringList;
  nLeft, nTop, nWidth, nHeight: Integer;
begin
  sl := TStringList.Create;
  sl.CommaText := s;
  nLeft := StrToIntDef(sl.Values['Left'], 200);
  nTop := StrToIntDef(sl.Values['Top'], 200);
  nWidth := StrToIntDef(sl.Values['Width'], 200);
  nHeight := StrToIntDef(sl.Values['Height'], 200);
  BoundsRect := Rect(nLeft, nTop, nLeft + nWidth, nTop + nHeight);
  m_ws := TWindowState(StrToIntDef(sl.Values['WindowState'], 0));
  sl.Free;
end;


procedure TMainForm.HandleDockHandlerRefresh(Sender: TObject);
begin
  timerRedrawHostingPageControls.Enabled := True;
end;


procedure TMainForm.RedrawHostingPageControls;
var
  i: Integer;
  sl: TStringList;
  mdi: TMDIChild;
  bHelp: Boolean;
begin
  if GetVisibleDockClientCount(dpLeft) = 0 then begin
    splitLeft.Visible := False;
    splitLeft.Align := alNone;
    dpLeft.Width := 0;
  end else begin
    if not splitLeft.Visible then begin
      splitLeft.Align := alNone;
      if dpLeft.Width = 0 then dpLeft.Width := 200;
      splitLeft.Left := dpLeft.Left + dpLeft.Width + 10;
      splitLeft.Align := alLeft;
      splitLeft.Visible := True;
    end;
  end;
  if GetVisibleDockClientCount(dpRight) = 0 then begin
    splitRight.Visible := False;
    splitRight.Align := alNone;
    dpRight.Width := 0;
  end else begin
    if not splitRight.Visible then begin
      if dpRight.Width = 0 then dpRight.Width := 200;
      splitRight.Align := alRight;
      splitRight.Visible := True;
    end;
  end;
  if GetVisibleDockClientCount(dpTop) = 0 then begin
    splitTop.Visible := False;
    splitTop.Align := alNone;
    dpTop.Height := 0;
  end else begin
    if not splitTop.Visible then begin
      splitTop.Align := alNone;
      if dpTop.Height = 0 then begin
        dpTop.Height := 200;
      end;
      splitTop.Top := dpTop.Top + dpTop.Height + 10;
      splitTop.Align := alTop;
      splitTop.Visible := True;
      pnlTabs.Top := splitTop.Top + 10;
    end;
  end;
  if GetVisibleDockClientCount(dpBottom) = 0 then begin
    splitBottom.Visible := False;
    splitBottom.Align := alNone;
    dpBottom.Height := 0;
  end else begin
    if not splitBottom.Visible then begin
      if dpBottom.Height = 0 then dpBottom.Height := 200;
      StatusBar.Top := Height;
      splitBottom.Top := 0;
      splitBottom.Align := alBottom;
      splitBottom.Visible := True;
    end;
  end;
  // Close all empty mdi docking hosts
  sl := TStringList.Create;
  for i := 0 to DockHandler.DockHostCount - 1 do begin
    if DockHandler.DockHosts[i].DockClientCount = 0 then begin
      sl.AddObject('', DockHandler.DockHosts[i]);
    end else if not(DockHandler.DockHosts[i].DockClients[0].Visible) then begin
      sl.AddObject('', DockHandler.DockHosts[i]);
    end;
  end;
  bHelp := False;
  for i := 0 to sl.Count - 1 do begin
    mdi := TMDIChild(sl.Objects[i]);
    if mdi.Caption = '<' + frmHelp.Caption + '>' then bHelp := True;
    mdi.Close;
  end;
  sl.Free;
  // Redraw captions of all registered dock clients
  for i := 0 to DockHandler.DockClientCount - 1 do begin
    if DockHandler.DockClients[i] is TDockableForm then begin
      TDockableForm(DockHandler.DockClients[i]).RefreshCaption;
    end;
  end;
  // Reset bounds of all dock panels
  for i := 0 to DockHandler.DockPanelCount - 1 do begin
    DockHandler.DockPanels[i].DockManager.ResetBounds(True);
  end;
  if bHelp then frmHelp.RequestBringToFront;
end;


function TMainForm.IsExecutable(sFileName: String): Boolean;
var
  sExt: String;
begin
  sExt := LowerCase(ExtractFileExt(sFileName));
  Result := (sExt = '.pl') or (sExt = '.plx') or (sExt = '.cgi') or (sExt = '.plex');
end;


procedure TMainForm.SaveIDESetting(sSection, sEntry, sValue: String);
begin
  ConfigStorage.WriteString(sSection, sEntry, sValue);
end;


procedure TMainForm.SetExecutionState(xs: TExecutionState);
begin
  m_ExecutionState := xs;
  UpdateActions;
  case ExecutionState of
    ecsNone: StatusBar.Panels[0].Text := 'Ready';
    ecsPendingCommand: StatusBar.Panels[0].Text := 'Waiting...';
    ecsCompile: StatusBar.Panels[0].Text := 'Compiling...';
    ecsDebug: StatusBar.Panels[0].Text := 'Debug state';
    ecsRun: StatusBar.Panels[0].Text := 'Running...';
  else
  end;
end;


procedure TMainForm.UpdateActions;
var
  mdi: TMDIChild;
  i: Integer;
begin
  acCompile.Enabled := (m_sActiveProjectFile <> '') and (ExecutionState = ecsNone);
  acRun.Enabled := (m_sActiveProjectFile <> '') and (ExecutionState in [ecsNone, ecsDebug]);
  acStepOver.Enabled := (m_sActiveProjectFile <> '') and (ExecutionState in [ecsNone, ecsDebug]);
  acStepInto.Enabled := ExecutionState = ecsDebug;
  acProgramReset.Enabled := ExecutionState = ecsDebug;
  acForceScriptTermination.Enabled := ExecutionState <> ecsNone;
  if ActiveMDIChild = nil then begin
    acUndo.Enabled := False;
    acRedo.Enabled := False;
    acFileSave.Enabled := False;
    acFind.Enabled := False;
    acSearchAgain.Enabled := False;
    acReplace.Enabled := False;
    acGoToLineNumber.Enabled := False;
  end else begin
    mdi := TMDIChild(ActiveMDIChild);
    acUndo.Enabled := mdi.SynEdit.CanUndo;
    acRedo.Enabled := mdi.SynEdit.CanRedo;
    acFileSave.Enabled := mdi.HasChanged and (not mdi.ReadOnly);
    acFind.Enabled := not mdi.UseDockManager;
    acSearchAgain.Enabled := not mdi.UseDockManager;
    acReplace.Enabled := not mdi.UseDockManager;
    acGoToLineNumber.Enabled := not mdi.UseDockManager;
  end;
  acSaveAll.Enabled := False;
  for i := 0 to MDIChildCount - 1 do begin
    mdi := TMDIChild(MDIChildren[i]);
    if mdi.HasChanged and (not mdi.ReadOnly) then begin
      acSaveAll.Enabled := True;
      break;
    end;
  end;

end;



procedure TMainForm.WndProc(var Message: TMessage);
var
  i: Integer;
begin
  inherited WndProc(Message);
  if (Message.Msg = WM_ACTIVATEAPP) and (not m_bPendingFileAgeCheck) then begin
    m_bPendingFileAgeCheck := True;
    for i := 0 to MDIChildCount - 1 do begin
      TMDIChild(MDIChildren[i]).CheckFileAge;
    end;
    m_bPendingFileAgeCheck := False;
    UpdateActions;
  end;
end;



function TMainForm.InternalExpandFileName(sFileName: String): String;
var
  sOldDirectory: String;
  dwDirSize: DWord;
begin
  Result := sFileName;
  if m_sLastProjectExecuted <> '' then begin
    sOldDirectory := '';
    dwDirSize := GetCurrentDirectory(0, nil);
    if dwDirSize > 0 then begin
      SetLength(sOldDirectory, dwDirSize);
      GetCurrentDirectory(dwDirSize, @sOldDirectory[1]);
    end;
    SetCurrentDirectory(PChar(ExtractFilePath(m_sLastProjectExecuted)));
    Result := ExpandFileName(sFileName);
    if sOldDirectory <> '' then SetCurrentDirectory(PChar(sOldDirectory));
  end;
end;


procedure TMainForm.SendBreakpointsToDebugger(bpl: TBreakpointList);
var
  i: Integer;
begin
  for i := 0 to bpl.Count - 1 do begin
    m_ReqProc.Request(DM_CHANGE_BP_REQ,
        bpl.Name + #13#10
      + IntToStr(bpl[i].Line) + #13#10
      + bpl[i].Condition + #13#10
      + 'TRUE', 1);
  end;
end;


procedure TMainForm.DispatchBPChangeEvent(Sender: TObject; sFileName: String; nLine: Integer; sCondition: String; bDelete: Boolean);
var
  mdi: TMDIChild;
begin
  if Sender is TMDIChild then begin
    // Dispatch to breakpoint table
    if bDelete
      then frmBreakpoints.DeleteBreakpoint(Sender, sFileName, nLine, sCondition)
      else frmBreakpoints.AddBreakpoint(Sender, sFileName, nLine, sCondition);
  end else begin
    // Dispatch to MDI child
    mdi := ChildFromFileName(sFileName);
    if mdi <> nil then begin
      if bDelete
        then mdi.DeleteBreakpoint(Sender, sFileName, nLine, sCondition)
        else mdi.AddBreakpoint(Sender, sFileName, nLine, sCondition);
    end else begin
      frmBreakpoints.Breakpoints[sFileName].Save;
    end;
  end;
  if bDelete
    then m_ReqProc.Request(DM_CHANGE_BP_REQ, sFileName + #13#10 + IntToStr(nLine) + #13#10#13#10'FALSE', 1)
    else m_ReqProc.Request(DM_CHANGE_BP_REQ, sFileName + #13#10 + IntToStr(nLine) + #13#10 + sCondition + #13#10'TRUE', 1);
end;



function TMainForm.DragEnter(const dataObj: IDataObject; grfKeyState: Longint;
      pt: TPoint; var dwEffect: Longint): HResult;
var
  formatEtc: TFormatEtc;
  stgMedium: TStgMedium;
begin
  if dataObj = nil then begin
    Result := S_OK;
    exit;
  end;
  with formatEtc do begin
    cfFormat := CF_HDROP;
    ptd := nil;
    dwAspect := DVASPECT_CONTENT;
    lindex := -1;
    tymed := TYMED_HGLOBAL;
  end;
  if Succeeded(dataObj.GetData(formatEtc, stgMedium)) then begin
    dwEffect := DROPEFFECT_COPY;
    Result := S_OK;
  end else begin
    dwEffect := DROPEFFECT_NONE;
    Result := S_FALSE;
  end;
end;


function TMainForm.DragOver(grfKeyState: Longint; pt: TPoint;
      var dwEffect: Longint): HResult;
begin
  dwEffect := DROPEFFECT_COPY;
  Result := S_OK;
end;


function TMainForm.DragLeave: HResult;
begin
  Result := S_OK;
end;


function TMainForm.Drop(const dataObj: IDataObject; grfKeyState: Longint;
  pt: TPoint; var dwEffect: Longint): HResult;
var
  formatEtc: TFormatEtc;
  stgMedium: TStgMedium;
  i, nCount: Integer;
  buf: array[0..MAX_PATH] of char;
begin
  if dataObj = nil then begin
    Result := S_OK;
    exit;
  end;
  with formatEtc do begin
    cfFormat := CF_HDROP;
    ptd := nil;
    dwAspect := DVASPECT_CONTENT;
    lindex := -1;
    tymed := TYMED_HGLOBAL;
  end;
  if Succeeded(dataObj.GetData(formatEtc, stgMedium)) then begin
    try
      nCount := DragQueryFile(stgMedium.hGlobal, $FFFFFFFF, @buf, SizeOf(buf));
      for i := 0 to nCount - 1 do begin
        DragQueryFile(stgMedium.hGlobal, i, @buf, SizeOf(buf));
        ShowFile(buf, -1, False, ExecutionState <> ecsDebug);
      end;
    finally
      ReleaseStgMedium(stgMedium);
    end;
  end;
  Result := S_OK;
end;


procedure TMainForm.ShowError(sFileName: String; nLine: Integer);
var
  mdi: TMDIChild;
begin
  sFileName := InternalExpandFileName(sFileName);
  if FileExists(sFileName) then begin
    mdi := ShowFile(InternalExpandFileName(sFileName), nLine, True, False);
    windows.SetFocus(mdi.Handle);
  end;
end;


procedure TMainForm.SendToStdIn(s: String);
begin
  case ExecutionState of
    ecsRun: begin
      m_clpPerl.Input(s);
    end;
  else
    m_ReqProc.Dispatcher.SendToStdIn(s);
  end;
end;


function TMainForm.GetBreakpointCount: Integer;
begin
  Result := frmBreakpoints.Count;
end;


procedure TMainForm.HandleCLEvent(Sender: TObject; sData: String; bError, bTerminate: Boolean);
begin
  if bError then begin
    ReceiveFromStdErr(sData);
  end else begin
    ReceiveFromStdOut(sData);
  end;
  if bTerminate then begin
    HandleTerminate;
  end;
end;


procedure TMainForm.UpdateProjectMenu;
var
  i: Integer;
  mi: TMenuItem;
  sl: TStringList;
  mdi: TMDIChild;
begin
  if m_sActiveProjectFile = ''
    then Caption := 'Open Perl IDE <' + 'no active project' + '> '
    else Caption := 'Open Perl IDE <' + ExtractFileName(m_sActiveProjectFile) + '> ';

  miSetActiveProject.Clear;
  sl := TStringList.Create;
  for i := 0 to MDIChildCount - 1 do begin
    mdi := TMDIChild(MDIChildren[i]);
    if IsExecutable(mdi.FileName) then begin
      mi := TMenuItem.Create(Self);
      mi.Caption := StringReplace(mdi.FileName, '&', '&&', [rfReplaceAll]);
      mi.Checked := UpperCase(m_sActiveProjectFile) = UpperCase(mi.Caption);
      mi.OnClick := HandleActiveProjectClick;
      sl.AddObject(mi.Caption, mi);
    end;
  end;

  sl.Sort;
  for i := 0 to sl.Count - 1 do miSetActiveProject.Add(TMenuItem(sl.Objects[i]));


(*
  for i := 0 to MDIChildCount - 1 do
    sl.AddObject(TMDIChild(MDIChildren[i]).FileName, MDIChildren[i]);
  sl.Sort;
  for i := 0 to sl.Count - 1 do begin
    if IsExecutable(TMDIChild(sl.Objects[i]).FileName) then begin
      mi := TMenuItem.Create(Self);
      mi.Caption := StringReplace(TMDIChild(sl.Objects[i]).FileName, '&', '&&', [rfReplaceAll]);
      mi.Checked := UpperCase(m_sActiveProjectFile) = UpperCase(mi.Caption);
      mi.OnClick := HandleActiveProjectClick;
      miSetActiveProject.Add(mi);
    end;
  end;
*)
  sl.Free;
end;


procedure TMainForm.ChangeProject(sNewProjectFileName: String);
begin
  SaveProjectSettings;
  m_sActiveProjectFile := sNewProjectFileName;
  LoadProjectSettings;
  UpdateProjectMenu;
end;

procedure TMainForm.HandleActiveProjectClick(Sender: TObject);
var
  sNewProject: String;
begin
  sNewProject := TMenuItem(Sender).Caption;
  sNewProject := StringReplace(sNewProject, '&&', #13, [rfReplaceAll]);
  sNewProject := StringReplace(sNewProject, '&', '', [rfReplaceAll]);
  sNewProject := StringReplace(sNewProject, '#13', '&', [rfReplaceAll]);
  ShowFile(sNewProject, -1, False, True);
end;


procedure TMainForm.HandleHint(Sender: TObject);
begin
//  StatusBar.SimpleText := GetLongHint(Application.Hint);
  StatusBar.Panels[1].Text := GetLongHint(Application.Hint);
end;


const
  nBlockingEvalReEntranceCounter: Integer = 0;

function TMainForm.BlockingEval(sCode: String): String;
var
  OldExecState: TExecutionState;
  rcv: IMessageReceiver;
begin
  Result := '<Debugger is busy: Blocking evaluation aborted...>';

  // Don't allow re-entrance, which can be caused by the ProcessMessages-Loop below.
  if nBlockingEvalReEntranceCounter = 1 then exit;
  inc(nBlockingEvalReEntranceCounter);

  m_ReqProc.PauseProcessing;
  while WaitForSingleObject(m_ReqProc.ProcessingPaused.Handle, 100) <> WAIT_OBJECT_0 do begin
    Application.ProcessMessages;
  end;

  OldExecState := ExecutionState;
  ExecutionState := ecsPendingCommand;

  // Switching message receiver to self is safe, because in Debug- and Compile-
  // mode all requests are handled from RequestProcessor and dispatched to
  // *blocking* PerlDebugger. So if the RequestProcessor is paused, no single
  // line of perl code is executed and consequently no MsgReports or
  // Output/Error-Events are generated.
  // If we are in Run-Mode, the RequestProcessor is not used, so switching is
  // safe, too.
  rcv := m_ReqProc.Dispatcher.OnReceiveMessage;
  m_ReqProc.Dispatcher.OnReceiveMessage := Self;
  try
    m_ReqProc.Dispatcher.SendMessage(DM_EVAL_CODE_REQ, sCode);
    Result := m_sHintValue;
  finally
    m_ReqProc.Dispatcher.OnReceiveMessage := rcv;
    ExecutionState := OldExecState;
    m_ReqProc.ContinueProcessing;
    dec(nBlockingEvalReEntranceCounter);
  end;
end;


procedure TMainForm.HandleShowHint(var HintStr: string; var CanShow: Boolean;
  var HintInfo: THintInfo);
begin
  if not (HintInfo.HintControl is TSynEdit) then begin
    exit;
  end;
  HintInfo.ReshowTimeout := 1;
  if HintStr = '' then begin
    m_sOldHintString := '';
    Application.HideHint;
    exit;
  end;
  CanShow := (HintStr <> m_sOldHintString)
    and (ExecutionState = ecsDebug)
    and (HintStr <> '%') 
    and (copy(HintStr, 1, 1)[1] in ['\', '''', '"', '$', '@', '%', '0'..'9'])
    and (frmPreferences.chbEvaluateHint.Checked);
  m_sOldHintString := HintStr;

  if CanShow then HintStr := HintStr + ': '
    + BlockingEval('0'#13#10'ShowDerefValues(\' + HintStr + ')');
end;



function TMainForm.GetVisibleDockClientCount(win: TWinControl): Integer;
var
  i: Integer;
begin
  Result := 0;
  for i := 0 to win.DockClientCount - 1 do begin
    if win.DockClients[i].Visible then inc(Result);
  end;
end;


procedure TMainForm.SaveProjectSettings;
var
  i: Integer;
  sl: TStringList;
  s: String;
  cfg: TConfigStorage;
begin
  if m_sActiveProjectFile = '' then exit;
  cfg := TConfigFileStorage.Create(ChangeFileExt(m_sActiveProjectFile, '.vpd'));
  sl := TStringList.Create;
  cfg.WriteString('General', 'StartParameter', frmConsole.edtParams.Text);

  cfg.EraseSection('Breakpoints');
  sl.CommaText := frmBreakpoints.DataAsString;
  for i := 0 to sl.Count - 1 do begin
    cfg.WriteString('Breakpoints', IntToStr(i), sl[i]);
  end;

  cfg.EraseSection('Watches');
  s := frmVariables.DataAsString;
  i := 0;
  while s <> '' do begin
    cfg.WriteString('Watches', IntToStr(i), copy(s, 1, 1000));
    s := copy(s, 1001, MAXINT);
    inc(i);
  end;
  cfg.Free;
  sl.Free;
end;


procedure TMainForm.LoadProjectSettings;
var
  i: Integer;
  slSection, slValues: TStringList;
  cfg: TConfigStorage;
  s: String;
  mdi: TMDIChild;
begin
  if ([csDestroying] * ComponentState <> []) then exit;
  if m_sActiveProjectFile = '' then exit;
  slSection := TStringList.Create;
  slValues := TStringList.Create;
  cfg := TConfigFileStorage.Create(ChangeFileExt(m_sActiveProjectFile, '.vpd'));
  frmConsole.edtParams.Text := cfg.ReadString('General', 'StartParameter', '');
  cfg.ReadSection('Breakpoints', slSection);
  for i := 0 to slSection.Count - 1 do begin
    s := cfg.ReadString('Breakpoints', slSection[i], '');
    slValues.Add(s);
  end;
  frmBreakpoints.DataAsString := slValues.CommaText;
  // Iterate all mdi children and set breakpoints
  for i := 0 to MDIChildCount - 1 do begin
    mdi := TMDIChild(MDIChildren[i]);
    if not (csDestroying in mdi.ComponentState) then begin
      mdi.Breakpoints := frmBreakpoints.Breakpoints[mdi.FileName].AsString;
    end;
  end;

  cfg.ReadSection('Watches', slSection);
  s := '';
  for i := 0 to slSection.Count - 1 do begin
    s := s + cfg.ReadString('Watches', slSection[i], '');
  end;
  frmVariables.DataAsString := s;

  cfg.Free;
  slValues.Free;
  slSection.Free;
end;



procedure TMainForm.SaveSettings;
var
  sl: TStringList;
  i: Integer;
  mdi: TMDIChild;
begin
  SavePreferencesToIni;

  sl := TStringList.Create;

  ConfigStorage.WriteString('Environment', 'LastProject', m_sActiveProjectFile);


  ConfigStorage.EraseSection('Editor windows');

  for i := 0 to tcFiles.Tabs.Count - 1 do begin
    mdi := TMDIChild(tcFiles.Tabs.Objects[i]);
    if mdi.FileName <> '' then begin
      ConfigStorage.WriteString('Editor windows', mdi.FileName, mdi.AsString);
    end;
  end;

  ConfigStorage.Flush;
  sl.Free;
end;


procedure TMainForm.LoadSettings;
var
  sl: TStringList;
  sDesktop: String;
  pch: TPageControlHost;
begin
  sl := TStringList.Create;
  // Set current desktop
  sDesktop := ConfigStorage.ReadString('Environment', 'DefaultDesktop', '');
  if not LoadDesktop(sDesktop) then begin
    sDesktop := 'Default';
    if not LoadDesktop(sDesktop) then begin
      pch := TPageControlHost.Create(Self);
      pch.Visible := False;
      frmConsole.ManualDock(pch.PageControl);
      frmError.ManualDock(pch.PageControl);
      frmCallStack.ManualDock(pch.PageControl);
      frmConsole.Show;
      frmError.Show;
      frmCallStack.Show;
      pch.PageControl.ActivePage := pch.PageControl.Pages[0];
      pch.ManualDock(dpBottom);
      pch.Visible := True;

      pch := TPageControlHost.Create(Self);
      pch.Visible := False;
      frmVariables.ManualDock(pch.PageControl);
      frmBreakpoints.ManualDock(pch.PageControl);
      frmModules.ManualDock(pch.PageControl);
      frmVariables.Show;
      frmBreakpoints.Show;
      frmModules.Show;
      pch.PageControl.ActivePage := pch.PageControl.Pages[0];
      pch.ManualDock(dpLeft);
      pch.Visible := True;

      DockHandler.Refresh;

      Application.ProcessMessages;

      SaveDesktop(sDesktop);
      ConfigStorage.WriteString('Environment', 'DefaultDesktop', sDesktop);
    end;
  end;


  // Load all desktops names
  ConfigStorage.ReadSection('Desktops', sl);
  cbxDesktop.Items.Assign(sl);
  cbxDesktop.Text := sDesktop;

  // Editor windows
  sl.Clear;
  ConfigStorage.ReadSection('Editor windows', sl);


  FastLoadFiles(sl, ConfigStorage.ReadString('Environment', 'LastProject', ''));

  WindowState := m_ws;

  m_bInitializing := False;

  // Environment options
//  s := ConfigStorage.ReadString('Environment', 'LastProject', '');
//  if FileExists(s) then Result := s;

  ConfigStorage.Flush;
  sl.Free;

  LoadPreferencesFromIni;

  tmrHelp.Enabled := True;
end;


procedure TMainForm.SaveDesktop(sDesktopName: String);
begin
  ConfigStorage.WriteString('Desktops', sDesktopName, DockHandler.AsString);
  ConfigStorage.Flush;
end;


function TMainForm.LoadDesktop(sDesktopName: String): Boolean;
var
  s: String;
  frmActive: TForm;
begin
  frmActive := ActiveMDIChild;
//  cbxDesktop.SetFocus;
  s := ConfigStorage.ReadString('Desktops', sDesktopName, '');
  Result := s <> '';
  if Result then begin
    DockHandler.AsString := s;
    cbxDesktop.Text := sDesktopName;
  end;
  if frmActive <> nil then frmActive.BringToFront;
end;


procedure TMainForm.StartDebugging(sParams: String; bStepInto: Boolean);
var
  sPerl: String;
begin
  if ExecutionState = ecsPendingCommand then exit;
  if ExecutionState = ecsNone then begin
    acSaveAllExecute(nil);
    if not frmPreferences.GetPathToPerl(sPerl) then exit;
    sPerl := sPerl + 'perl.exe';
    ExecutionState := ecsPendingCommand;
    SaveProjectSettings;
    frmCallStack.eltCallStack.Items.Clear;
    frmConsole.memoConsole.Clear;
    frmCommunicationLog.memoCommunicationLog.Clear;
    frmError.memoErrorOutput.Clear;
    frmModules.eltModules.Items.Clear;
    frmConsole.memoConsole.Font.Color := m_colActiveConsoleFontColor;
    m_sLastProjectExecuted := m_sActiveProjectFile;
    if bStepInto
      then m_ReqProc.Request(DM_START_REQ, sPerl + #13#10 + m_sActiveProjectFile
        + #13#10 + frmConsole.edtParams.Text
        + #13#10'TRUE'#13#10'FALSE', 0)
      else m_ReqProc.Request(DM_START_REQ, sPerl + #13#10 + m_sActiveProjectFile
        + #13#10 + frmConsole.edtParams.Text
        + #13#10'FALSE'#13#10'FALSE', 0);
    if (frmPreferences.cbxDebugDesktop.Text <> cbxDesktop.Text)
      then LoadDesktop(frmPreferences.cbxDebugDesktop.Text);
  end;
end;


function TMainForm.ReceiveFromStdErr(sData: String): Integer;
begin
  Result := -1;
  if csDestroying in ComponentState then exit;

  frmError.Visible := True;

  with frmError.memoErrorOutput.Lines do begin
    while (Count > frmPreferences.ErrorWindowBuffer) and (Count > 0) do Delete(0);
  end;

  AddTextToList(sData, frmError.memoErrorOutput.Lines,
    m_bStdErrReplace, m_sStdErrReplace);

  Result := 0;
end;


function TMainForm.HandleTerminate: Integer;
var
  i: Integer;
  mdi: TMDIChild;
  sFileName: String;
  nLine: Integer;
begin
  Result := 0;
  if csDestroying in ComponentState then exit;
  if ExecutionState <> ecsNone then begin
    if ExecutionState = ecsDebug then begin
      ExecutionState := ecsPendingCommand;
      m_ReqProc.Request(DM_STOP_REQ, '', 0);
    end;
    ExecutionState := ecsNone;

    frmVariables.ClearWatchTree;

    SaveProjectSettings;
    frmConsole.memoConsole.Font.Color := frmPreferences.PassiveConsole.ForegroundColor;
    for i := 0 to MDIChildCount - 1 do begin
      mdi := TMDIChild(MDIChildren[i]);

      if not mdi.ReadOnly then begin
        mdi.SynEdit.ReadOnly := False;
        mdi.SynEdit.Font.Color := frmPreferences.SynEdit.Font.Color;
        mdi.SynEdit.Color := frmPreferences.SynEdit.Color;
      end;

      mdi.SetCurrentLine(-1);
    end;
    if ActiveMDIChild <> nil then windows.SetFocus(ActiveMDIChild.Handle);
    frmError.memoErrorOutput.Lines.Add('');
    with frmError.memoErrorOutput.Lines do begin
      i := 0;
      while (i < Count) do begin
        if frmError.ParseErrorLine(Strings[i], sFileName, nLine) then begin
          ShowError(sFileName, nLine);
          break;
        end;
        inc(i);
      end;
    end;
    if (frmPreferences.cbxDefaultDesktop.Text <> cbxDesktop.Text) then begin
      LoadDesktop(frmPreferences.cbxDefaultDesktop.Text);
    end;

  end;
end;


procedure TMainForm.AddTextToList(sData: String;
  sl: TStrings; var bReplaceMode: Boolean; var sReplaceStr: String);
var
  i, nCount: Integer;
  s, h: String;

  procedure AppendOrReplaceData;
  begin
    if bReplaceMode then begin
      if s <> '' then begin
        h := sl[nCount - 1];
        if Length(s) < Length(h)
          then h := s + copy(h, Length(s) + 1, Length(h) - Length(s))
          else h := s;
        sl[nCount - 1] := h;
      end;
    end else sl[nCount - 1] := sl[nCount - 1] + s;
    s := '';
  end;

begin
  if sData = '' then exit;
  if sl.Count = 0 then begin
    sl.AddObject('', TObject(0));
    bReplaceMode := False;
    sReplaceStr := '';
  end;
  nCount := sl.Count;
  if bReplaceMode then s := sReplaceStr else s := '';
  for i := 1 to Length(sData) do begin
    case sData[i] of
      #13: begin
        AppendOrReplaceData;
        bReplaceMode := True;
      end;
      #10: begin
        AppendOrReplaceData;
        sl.Add('');
        inc(nCount);
        bReplaceMode := False;
      end;
    else
      s := s + sData[i];
    end;
  end;
  if bReplaceMode then sReplaceStr := s else sReplaceStr := '';
  AppendOrReplaceData;
end;


function TMainForm.ReceiveFromStdOut(sData: String): Integer;
begin
  if csDestroying in ComponentState then begin
    Result := -1;
    exit;
  end;

  frmConsole.Visible := True;

  with frmConsole.memoConsole.Lines do begin
    while (Count > frmPreferences.ConsoleWindowBuffer) and (Count > 0) do Delete(0);
  end;

  AddTextToList(sData, frmConsole.memoConsole.Lines,
    m_bStdOutReplace, m_sStdOutReplace);

  Result := 0;
end;


procedure TMainForm.ShowWatches;
var
  i: Integer;
  it: TElTreeItem;
  sCode: String;
begin
  for i := 0 to frmVariables.eltWatches.Items.VisCount - 1 do begin
    it := frmVariables.eltWatches.Items.ItemAsVis[i];
    if it <> nil then begin
      if it.Text <> '' then begin
        sCode := it.GetFullNameEx('->', False);
        m_ReqProc.Request(DM_EVAL_CODE_REQ,
          IntToStr(Longint(it)) + #13#10 + 'ShortEval(\' + sCode + ')',
          100 + i * 10);
      end;
    end;
  end;
end;


function TMainForm.ChildFromFileName(sFileName: String): TMDIChild;
var
  i: Integer;
  sTransformedName, sTransformedResultName: String;
begin
  i := 0;
  Result := nil;
  sTransformedName := StringReplace(sFileName, '/', '\', [rfReplaceAll]);
  while i < MDIChildCount do begin
    Result := TMDIChild(MDIChildren[i]);
    if not Result.IsDockHost then begin
      sTransformedResultName := StringReplace(Result.FileName, '/', '\', [rfReplaceAll]);
      if UpperCase(sTransformedResultName) = UpperCase(sTransformedName)
        then break
        else Result := nil;
    end else Result := nil;
    inc(i);
  end;
end;

function TMainForm.ShowFile(sFileName: String; nLine: Integer; bError: Boolean; bChangeProject: Boolean; mdi: TMDIChild = nil): TMDIChild;
var
  wnd: HWnd;
begin
  if mdi = nil
    then Result := ChildFromFileName(sFileName)
    else Result := mdi;
  if Result <> nil then begin
    if Result <> ActiveMDIChild then begin
      wnd := GetWindow(Result.Handle, GW_HWNDNEXT);
      SendMessage(ClientHandle, WM_MDINEXT, wnd, 1);
    end;
  end else begin
    sFileName := StringReplace(sFileName, '/', '\', [rfReplaceAll]);
    Result := CreateMDIChild(sFileName, bChangeProject);
  end;
  if nLine > -1 then begin
    if bError then begin
      Result.SetErrorLine(nLine)
    end else Result.SetCurrentLine(nLine);
  end;
  if bChangeProject and IsExecutable(Result.FileName) then begin
    ChangeProject(Result.FileName);
  end;
end;



procedure ParseEvalData(const sData: String; out sRequestID, sName, sValue: String);
var
  i, nFirst: Integer;
begin
  nFirst := 1;
  sRequestID := '';
  sName := '';
  sValue := '';
  i := 1;
  while i <= Length(sData) do begin
    if sData[i] in [#13, #10] then begin
      if nFirst = 1 then begin
        sRequestID := copy(sData, 1, i - 1);
        nFirst := i + 1;
        if sData[i] = #13 then inc(nFirst);
      end else begin
        sName := copy(sData, nFirst, i - nFirst);
        nFirst := i + 1;
        if sData[i] = #13 then inc(nFirst);
        sValue := copy(sData, nFirst, MAXINT);
        exit;
      end;
    end;
    inc(i);
  end;
end;


function TMainForm.HandleDebugMessage(nMsgID: Integer; sData: String): Integer;
var
  sl: TStringList;
  s, sName, sValue: String;
  nLevel: Integer;
  mdi: TMDIChild;
  eltItem: TElTreeItem;
  sRequestID: String;
  elt: TElTreeItem;
  sMsg, sError: String;
  i: Integer;
begin
  if (csDestroying in ComponentState) or (ExecutionState = ecsNone) then begin
    Result := -1;
    exit;
  end;
  sl := TStringList.Create;
  Result := 0;
  case nMsgID of
    DM_CMD_RSP: begin
      sl.Text := sData;
      sMsg := MsgToStr(StrToInt(sl[0]));
      sError := ErrorToStr(StrToInt(sl[1]));
      if (sMsg = 'DM_START_REQ') and (sError = 'DEC_OK')
        then m_dtDebugStartTime := Now;  
      s := 'Dispatching ' + sMsg + ': ' + sError;
      frmCommunicationLog.memoCommunicationLog.Lines.Add(FormatDateTime('YYYYMMDDHHMMSSZZZ', Now) + ': ' + s);
    end;
    DM_START_REP: begin
      if ExecutionState = ecsPendingCommand then ExecutionState := ecsDebug;
    end;
    DM_STOP_REP: begin
    end;
    DM_LINE_REP: begin
      if (ExecutionState = ecsDebug) and (not m_bIgnoreLineReport) then begin
        sl.Text := sData;
        ShowFile(sl[0], StrToInt(sl[1]), False, False);
        ShowWatches;
        m_ReqProc.Request(DM_CALLSTACK_REQ, '1', 101);
      end;
      m_bIgnoreLineReport := False;
    end;
    DM_EVAL_CODE_REP: begin
      ParseEvalData(sData, sRequestID, sName, sValue);
      if sValue = '' then sValue := '<undef>';
      if ExecutionState = ecsPendingCommand then begin
        m_sHintValue := sValue;
      end else begin
        frmVariables.UpdateVariable(sRequestID, sName, sValue);
      end;
    end;
    DM_MODULE_LOADED_REP: begin
      eltItem := frmModules.eltModules.Items.AddItem(nil);
      sData := StringReplace(sData, '/', '\', [rfReplaceAll]);
      eltItem.Text := IntToHex(frmModules.eltModules.Items.Count, 4) + ': ' + IntToStr(round((Now - m_dtDebugStartTime) * 86400 * 1000));
      eltItem.SubItems.Add(ExtractFileName(sData));
      eltItem.SubItems.Add(sData);
      // Set all breakpoints for this module
      SendBreakpointsToDebugger(frmBreakpoints.Breakpoints[sData]);
      mdi := ChildFromFileName(sData);

      if mdi <> nil then begin
        mdi.SynEdit.Font.Color := frmPreferences.ReadOnlyEditorMode.ForegroundColor;
        mdi.SynEdit.Color := frmPreferences.ReadOnlyEditorMode.BackgroundColor;
        mdi.SynEdit.ReadOnly := True;
      end;

    end;
    DM_CALLSTACK_REP: begin
      sl.Text := sData;
      nLevel := StrToInt(sl[0]);
      if nLevel = 1 then frmCallStack.eltCallstack.Items.Clear;
      if (sl.Count > 1) and (ExecutionState = ecsDebug) then begin
        elt := frmCallStack.eltCallStack.Items.AddItem(nil);
        elt.Text := sl[0];
        elt.SubItems.Add(sl[1]);
        m_ReqProc.Request(DM_CALLSTACK_REQ, IntToStr(nLevel + 1),
          100 + nLevel + 1);
      end;
    end;
  else
  end;

  if nMsgID <> DM_CMD_RSP then begin
    s := 'Receiving ' + MsgToStr(nMsgID) + ': ' + sData;
    s := StringReplace(s, #13#10, ', ', [rfReplaceAll]);
    sl.Clear;
    if frmCommunicationLog.memoCommunicationLog.Lines.Count > 100 then begin
      for i := frmCommunicationLog.memoCommunicationLog.Lines.Count - 100 to frmCommunicationLog.memoCommunicationLog.Lines.Count - 1 do begin
        sl.Add(frmCommunicationLog.memoCommunicationLog.Lines[i]);
      end;
      frmCommunicationLog.memoCommunicationLog.Text := sl.Text;
    end;

    frmCommunicationLog.memoCommunicationLog.Lines.Add(FormatDateTime('YYYYMMDDHHMMSSZZZ', Now) + ': ' + s);
  end;
  sl.Free;

end;


procedure TMainForm.FastLoadFiles(slFiles: TStringList; sActiveProject: String);
var
  sl: TStringList;
  mdi: TMDIChild;
  sFileName: String;
  i: Integer;
begin
  sl := TStringList.Create;

  // Get list of all existing mdi children to avoid duplicates
  for i := 0 to tcFiles.Tabs.Count - 1 do begin
    sl.Add(TMDIChild(tcFiles.Tabs.Objects[i]).FileName);
  end;
  sl.Sorted := True;

  for i := 0 to slFiles.Count - 1 do begin
    sFileName := StringReplace(slFiles[i], '/', '\', [rfReplaceAll]);
    if sl.IndexOf(sFileName) = -1 then begin
      if FileExists(sFileName) then begin
        mdi := TMDIChild.Create(Application);
        mdi.OpenFile(sFileName);
        mdi.AsString := ConfigStorage.ReadString('Editor windows', sFileName, '');
        tcFiles.TabIndex := tcFiles.Tabs.AddObject(ExtractFileName(mdi.Caption), mdi);
      end;
    end;
  end;

  sl.Free;

  if FileExists(sActiveProject) then begin
    ShowFile(sActiveProject, -1, False, True);
  end else begin
    i := 0;
    while i < tcFiles.Tabs.Count do begin
      mdi := TMDIChild(tcFiles.Tabs.Objects[i]);
      if FileExists(mdi.FileName) then begin
        ShowFile(mdi.FileName, -1, False, True, mdi);
        exit;
      end;
      inc(i); 
    end;
  end;
end;


function TMainForm.CreateMDIChild(const Name: string; bChangeProject: Boolean): TMDIChild;
begin
  Result := TMDIChild.Create(Application);
  Result.Caption := Name;

  if (Name = '') or (FileExists(Name)) then begin
    Result.OpenFile(Name);
    if IsExecutable(Name) then begin
      if bChangeProject
        then ChangeProject(Name)
        else UpdateProjectMenu;
    end;

    Result.Breakpoints := frmBreakpoints.Breakpoints[Name].AsString;

    if ExecutionState = ecsDebug then begin
      Result.SynEdit.Font.Color := frmPreferences.ReadOnlyEditorMode.ForegroundColor;
      Result.SynEdit.Color := frmPreferences.ReadOnlyEditorMode.BackgroundColor;
      Result.SynEdit.ReadOnly := True;
      SendBreakpointsToDebugger(frmBreakpoints.Breakpoints[Name]);
    end;
  end;

  tcFiles.Tabs.InsertObject(0, ExtractFileName(Result.Caption), Result);

  tcFiles.TabIndex := 0;
  UpdateActions;
end;

procedure TMainForm.acFileNewExecute(Sender: TObject);
begin
  ShowFile('', -1, False, False);
end;

procedure TMainForm.acFileOpenExecute(Sender: TObject);
var
  i: Integer;
begin
  if OpenDialog.Execute then begin
    for i := 0 to OpenDialog.Files.Count - 1 do
      ShowFile(OpenDialog.Files[i], -1, False, ExecutionState <> ecsDebug);
  end;
end;

procedure TMainForm.acFileExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  sDebugScriptTemplate: String;
  sl: TStringList;
begin
  triggerProc := ActivationFromOtherInstance;
  DockHandler.OnRefresh := HandleDockHandlerRefresh;
  DockHandler.OnSetOtherHostsAsString := HandleSetOtherHostsAsString;
  DockHandler.OnGetOtherHostsAsString := HandleGetOtherHostsAsString;
  m_bInitializing := True;
  OleInitialize(nil);
  OleCheck(RegisterDragDrop(Handle, Self));
  m_sAppPath := ExtractFilePath(Application.ExeName);
  Application.HintPause := 0;
  Application.OnShowHint := HandleShowHint;
  Application.OnHint := HandleHint;
  m_sIniFileName := ExtractFilePath(Application.ExeName) + 'PerlIDE.ini';
  m_ConfigStorage := TConfigFileStorage.Create(m_sIniFileName);
  sDebugScriptTemplate := ExtractFilePath(Application.ExeName) + 'dbTemplate.txt';
  if not FileExists(sDebugScriptTemplate) then begin
    memoDebugScriptTemplate.Lines.SaveToFile(sDebugScriptTemplate);
  end else begin
    sl := TStringList.Create;
    try
      sl.LoadFromFile(sDebugScriptTemplate);
      if sl.Count > 0 then begin
        if sl[0] <> memoDebugScriptTemplate.Lines[0] then begin
          memoDebugScriptTemplate.Lines.SaveToFile(sDebugScriptTemplate);
        end;
      end else begin
        memoDebugScriptTemplate.Lines.SaveToFile(sDebugScriptTemplate);
      end;
    finally
      sl.Free;
    end;
  end;
  ExecutionState := ecsNone;
  m_ReqProc := TRequestProcessor.Create(TPerlDebugger.Create(Self) as IMessageDispatcher);
  dpLeft.Width := 0;
  dpRight.Width := 0;
  dpTop.Height := 0;
  dpBottom.Height := 0;
  cbxDesktop.ItemIndex := 0;
end;

procedure TMainForm.FormShow(Sender: TObject);
var
  sParam: String;
  i: Integer;
begin
  m_colActiveConsoleFontColor := clAqua;
  frmPreferences.PassiveConsole.ForegroundColor := clSilver;
  frmGoto.OnGoto := HandleGoto;

  LoadSettings;

  if ParamCount > 0 then begin
    sParam := ParamStr(1);

    for i := 1 to ParamCount do begin
      sParam := InternalGetLongPathName(ParamStr(i));
      if FileExists(sParam) then ShowFile(sParam, -1, False, True);
    end;
  end else begin
//    if FileExists(s) then ShowFile(s, -1, False, True);
  end;
  UpdateActions;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  m_ReqProc.Free;
  RevokeDragDrop(Handle);
  OleUninitialize;
  m_ConfigStorage.Free;
end;

procedure TMainForm.acStepOverExecute(Sender: TObject);
begin
  if ExecutionState = ecsDebug
    then m_ReqProc.Request(DM_STEP_OVER_REQ, '', 10)
    else StartDebugging(frmConsole.edtParams.Text, False);
end;

procedure TMainForm.acStepIntoExecute(Sender: TObject);
begin
  if ExecutionState = ecsDebug
    then m_ReqProc.Request(DM_STEP_INTO_REQ, '', 5)
    else StartDebugging(frmConsole.edtParams.Text, False);
end;

procedure TMainForm.acRunExecute(Sender: TObject);
var
  sPerl: String;
begin
  if (GetBreakpointCount = 0) and (ExecutionState = ecsNone) then begin
    acSaveAllExecute(nil);
    if not frmPreferences.GetPathToPerl(sPerl) then exit;
    sPerl := sPerl + 'perl.exe';
    ExecutionState := ecsRun;
    frmCallStack.eltCallStack.Items.Clear;
    frmConsole.memoConsole.Clear;
    frmCommunicationLog.memoCommunicationLog.Clear;
    frmError.memoErrorOutput.Clear;
    frmModules.eltModules.Items.Clear;
    frmConsole.memoConsole.Font.Color := m_colActiveConsoleFontColor;
    if (frmPreferences.cbxRunDesktop.Text <> cbxDesktop.Text)
      then LoadDesktop(frmPreferences.cbxRunDesktop.Text);
    if m_clpPerl <> nil then m_clpPerl.Free;
    m_sLastProjectExecuted := m_sActiveProjectFile;
    m_clpPerl := TCLProcess.Create('"' + sPerl + '"'
      + '-I. "' + ExtractFileName(m_sActiveProjectFile) + '" ' + frmConsole.edtParams.Text,
      ExtractFilePath(m_sActiveProjectFile), HandleCLEvent);
  end else begin
    if ExecutionState = ecsNone then begin
      m_bIgnoreLineReport := True;
      StartDebugging(frmConsole.edtParams.Text, False);
    end;
    if ExecutionState in [ecsDebug, ecsPendingCommand]
      then m_ReqProc.Request(DM_RUN_REQ, '', 3);
  end;
end;

procedure TMainForm.acProgramResetExecute(Sender: TObject);
begin
  if ExecutionState = ecsDebug then begin
    ExecutionState := ecsPendingCommand;
    m_ReqProc.Request(DM_STOP_REQ, '', 0);
  end;
end;

procedure TMainForm.acFileSaveExecute(Sender: TObject);
begin
  if ActiveMDIChild <> nil then TMDIChild(ActiveMDIChild).SaveFile;
end;


var
  reg: TRegistry;

procedure TMainForm.cbxDesktopKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then begin
    if cbxDesktop.Text <> '' then begin
      if MessageBox(Application.Handle, PChar('Save current desktop as ' + cbxDesktop.Text + ' ?'),
        'Open Perl IDE', MB_YESNO) = IDYES then begin
        SaveDesktop(cbxDesktop.Text);
        if cbxDesktop.Items.IndexOf(cbxDesktop.Text) = -1
          then cbxDesktop.Items.Add(cbxDesktop.Text);
      end;
//      cbxDesktop.SetFocus;
    end;
    Key := #0;
  end;
end;


procedure TMainForm.cbxDesktopClick(Sender: TObject);
begin
  if cbxDesktop.Text <> '' then begin
    LoadDesktop(cbxDesktop.Text);
//    cbxDesktop.SetFocus;
  end;
end;


procedure TMainForm.SavePreferencesToIni;
var
  sl: TStringList;
  i: Integer;
  ms: TMemoryStream;
  s: String;
begin
  // Environment options
  ConfigStorage.WriteString('Environment', 'DefaultDesktop', frmPreferences.cbxDefaultDesktop.Text);
  ConfigStorage.WriteString('Environment', 'RunDesktop', frmPreferences.cbxRunDesktop.Text);
  ConfigStorage.WriteInteger('Environment', 'ConsoleWindowBuffer', frmPreferences.ConsoleWindowBuffer);
  ConfigStorage.WriteInteger('Environment', 'ErrorWindowBuffer', frmPreferences.ErrorWindowBuffer);
  // Directories
  ConfigStorage.WriteString('Directories', 'PathToPerl', frmPreferences.edtPathToPerl.Text);
  // Editor options
  if frmPreferences.chbEnableVirtualSpace.Checked
    then ConfigStorage.WriteString('Editor', 'EnableVirtualSpace', 'TRUE')
    else ConfigStorage.WriteString('Editor', 'EnableVirtualSpace', 'FALSE');
  if frmPreferences.chbFindTextAtCursor.Checked
    then ConfigStorage.WriteString('Editor', 'FindTextAtCursor', 'TRUE')
    else ConfigStorage.WriteString('Editor', 'FindTextAtCursor', 'FALSE');
  ConfigStorage.WriteInteger('Editor', 'TabWidth', frmPreferences.TabWidth);
  ConfigStorage.WriteInteger('Editor', 'RightEdge', frmPreferences.RightEdge); 
  // Fonts and Colors
  frmConsole.memoConsole.Font.Color := m_colActiveConsoleFontColor;
  ConfigStorage.Sections['Fonts/Colors'] := frmPreferences.FontsAndColorsAsString;
  // Highlighter options
  sl := TStringList.Create;
  sl.CommaText := frmPreferences.HighlighterAsString;
  for i := 0 to sl.Count - 1 do
    ConfigStorage.WriteString('Highlighter', sl.Names[i], sl.Values[sl.Names[i]]);
  sl.Free;
  // Debug options
  ConfigStorage.WriteString('Debug', 'Desktop', frmPreferences.cbxDebugDesktop.Text);
  if frmPreferences.chbEvaluateHint.Checked
    then ConfigStorage.WriteString('Debug', 'EvaluateHint', 'TRUE')
    else ConfigStorage.WriteString('Debug', 'EvaluateHint', 'FALSE');
  // Help options
  ConfigStorage.EraseSection('Help');
  if frmPreferences.RebuildKeywordIndex
    then ConfigStorage.WriteString('Help', 'RebuildKeywordIndex', 'TRUE')
    else ConfigStorage.WriteString('Help', 'RebuildKeywordIndex', 'FALSE');
  if frmPreferences.RebuildContents
    then ConfigStorage.WriteString('Help', 'RebuildContents', 'TRUE')
    else ConfigStorage.WriteString('Help', 'RebuildContents', 'FALSE');
  ms := TMemoryStream.Create;
  try
    try frmPreferences.eltHelp.Items.SaveToStream(ms); except end;
    SetLength(s, 2 * ms.Size);
    BinToHex(PChar(ms.Memory), PChar(s), ms.Size);
    i := 0;
    while s <> '' do begin
      ConfigStorage.WriteString('Help', 'Book_' + IntToHex(i, 8), copy(s, 1, 512));
      inc(i);
      s := copy(s, 513, MAXINT);
    end;
  finally
    ms.Free;
  end;

  ConfigStorage.Flush;
end;


procedure TMainForm.LoadPreferencesFromIni;
var
  i: Integer;
  mdi: TMDIChild;
  sl: TStringList;
  ms: TMemoryStream;
  s: String;
begin
  // Environment options
  frmPreferences.cbxDefaultDesktop.Items.Assign(cbxDesktop.Items);
  frmPreferences.cbxRunDesktop.Items.Assign(cbxDesktop.Items);
  frmPreferences.cbxDefaultDesktop.Text := ConfigStorage.ReadString('Environment', 'DefaultDesktop', cbxDesktop.Text);
  frmPreferences.cbxRunDesktop.Text := ConfigStorage.ReadString('Environment', 'RunDesktop', cbxDesktop.Text);
  frmPreferences.ConsoleWindowBuffer := ConfigStorage.ReadInteger('Environment', 'ConsoleWindowBuffer', 100);
  frmPreferences.ErrorWindowBuffer := ConfigStorage.ReadInteger('Environment', 'ErrorWindowBuffer', 100);
  // Directories
  frmPreferences.edtPathToPerl.Text := ConfigStorage.ReadString('Directories', 'PathToPerl', '');
  // Editor options
  frmPreferences.chbEnableVirtualSpace.Checked := ConfigStorage.ReadString('Editor', 'EnableVirtualSpace', 'TRUE') <> 'FALSE';
  frmPreferences.chbFindTextAtCursor.Checked := ConfigStorage.ReadString('Editor', 'FindTextAtCursor', 'TRUE') <> 'FALSE';
  frmPreferences.TabWidth := ConfigStorage.ReadInteger('Editor', 'TabWidth', 2);
  frmPreferences.RightEdge := ConfigStorage.ReadInteger('Editor', 'RightEdge', 80);
  // Fonts and Colors
  frmConsole.memoConsole.Font.Color := m_colActiveConsoleFontColor;
  s := ConfigStorage.Sections['Fonts/Colors'];
  if s <> '' then begin
    frmPreferences.FontsAndColorsAsString := s;
    m_colActiveConsoleFontColor := frmConsole.memoConsole.Font.Color;
  end;

  // Highlighter options
  sl := TStringList.Create;
  ConfigStorage.ReadSection('Highlighter', sl);
  for i := 0 to sl.Count - 1 do
    sl[i] := sl[i] + '=' + ConfigStorage.ReadString('Highlighter', sl[i], '');
  frmPreferences.HighlighterAsString := sl.CommaText;
  sl.Free;
  // Debug options
  frmPreferences.cbxDebugDesktop.Items.Assign(cbxDesktop.Items);
  frmPreferences.cbxDebugDesktop.Text := ConfigStorage.ReadString('Debug', 'Desktop', cbxDesktop.Text);
  frmPreferences.chbEvaluateHint.Checked := ConfigStorage.ReadString('Debug', 'EvaluateHint', 'TRUE') <> 'FALSE';
  // Help options
  frmPreferences.RebuildKeywordIndex := ConfigStorage.ReadString('Help', 'RebuildKeywordIndex', 'TRUE') <> 'FALSE';
  frmPreferences.RebuildContents := ConfigStorage.ReadString('Help', 'RebuildContents', 'TRUE') <> 'FALSE';
  ms := TMemoryStream.Create;
  sl := TStringList.Create;
  try
    ConfigStorage.ReadSection('Help', sl);
    i := sl.IndexOf('RebuildKeywordIndex'); if i > -1 then sl.Delete(i);
    i := sl.IndexOf('RebuildContents'); if i > -1 then sl.Delete(i);
    s := '';
    for i := 0 to sl.Count - 1 do
      s := s + ConfigStorage.ReadString('Help', sl[i], '');
    if s <> '' then begin
      ms.SetSize(Length(s) div 2);
      HexToBin(PChar(s), PChar(ms.Memory), Length(s));
      ms.Seek(0, soFromBeginning);
      try frmPreferences.eltHelp.Items.LoadFromStream(ms); except; end;
    end;
  finally
    sl.Free;
    ms.Free;
  end;

  if ActiveMDIChild <> nil then begin
    mdi := TMDIChild(ActiveMDIChild);
    if frmPreferences.chbEnableVirtualSpace.Checked
      then mdi.SynEdit.Options := mdi.SynEdit.Options + [eoScrollPastEol]
      else mdi.SynEdit.Options := mdi.SynEdit.Options - [eoScrollPastEol];
    mdi.SynEdit.Font.Assign(frmPreferences.SynEdit.Font);
    mdi.SynEdit.Gutter.Color := frmPreferences.SynEdit.Gutter.Color;
    mdi.SynEdit.RightEdgeColor := frmPreferences.SynEdit.RightEdgeColor;
    mdi.SynEdit.SelectedColor.Foreground := frmPreferences.SynEdit.SelectedColor.Foreground;
    mdi.SynEdit.SelectedColor.Background := frmPreferences.SynEdit.SelectedColor.Background;
    if mdi.SynEdit.ReadOnly then begin
      mdi.SynEdit.Font.Color := frmPreferences.ReadOnlyEditorMode.ForegroundColor;
      mdi.SynEdit.Color := frmPreferences.ReadOnlyEditorMode.BackgroundColor;
    end else begin
      mdi.SynEdit.Color := frmPreferences.SynEdit.Color;
    end;
    mdi.SynEdit.TabWidth := frmPreferences.TabWidth;
    mdi.SynEdit.RightEdge := frmPreferences.RightEdge;
  end;

  frmHelpContents.InternalBuildContentTree;

  if ExecutionState = ecsNone then begin
    frmConsole.memoConsole.Font.Color := frmPreferences.PassiveConsole.ForegroundColor;
  end;

end;


function TMainForm.ShowPreferences: Boolean;
begin
  LoadPreferencesFromIni;
  frmConsole.memoConsole.Font.Color := m_colActiveConsoleFontColor;
  Result := frmPreferences.ShowModal = mrOK;
  if Result then begin
    SavePreferencesToIni;
  end;
  LoadPreferencesFromIni;
end;


procedure TMainForm.acPreferencesExecute(Sender: TObject);
begin
  ShowPreferences;
end;

procedure TMainForm.Debugwindows1Click(Sender: TObject);
begin
  miVariables.Checked := frmVariables.Visible;
  miBreakpoints.Checked := frmBreakpoints.Visible;
  miModules.Checked := frmModules.Visible;
  miCallstack.Checked := frmCallStack.Visible;
end;

procedure TMainForm.miBreakpointsClick(Sender: TObject);
begin
  frmBreakpoints.Visible := not frmBreakpoints.Visible;
end;

procedure TMainForm.miCallstackClick(Sender: TObject);
begin
  frmCallStack.Visible := not frmCallStack.Visible;
end;

procedure TMainForm.miVariablesClick(Sender: TObject);
begin
  frmVariables.Visible := not frmVariables.Visible;
end;

procedure TMainForm.miModulesClick(Sender: TObject);
begin
  frmModules.Visible := not frmModules.Visible;
end;

procedure TMainForm.miConsoleClick(Sender: TObject);
begin
  frmConsole.Visible := not frmConsole.Visible;
end;

procedure TMainForm.miErrorOutputClick(Sender: TObject);
begin
  frmError.Visible := not frmError.Visible;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  try
    CanClose := True;
    m_bClosing := True;
    SaveSettings;
    SaveProjectSettings;
  except end;
end;

procedure TMainForm.acCompileExecute(Sender: TObject);
var
  sPerl: String;
begin
  if ExecutionState = ecsNone then begin
    if not frmPreferences.GetPathToPerl(sPerl) then exit;
    sPerl := sPerl + 'perl.exe';
    ExecutionState := ecsCompile;
    frmCallStack.eltCallStack.Items.Clear;
    frmConsole.memoConsole.Clear;
    frmCommunicationLog.memoCommunicationLog.Clear;
    frmError.memoErrorOutput.Clear;
    frmModules.eltModules.Items.Clear;
    frmConsole.memoConsole.Font.Color := m_colActiveConsoleFontColor;
    m_sLastProjectExecuted := m_sActiveProjectFile;
    m_ReqProc.Request(DM_START_REQ, sPerl + #13#10 + m_sActiveProjectFile
        + #13#10 + frmConsole.edtParams.Text
        + #13#10'FALSE'#13#10'TRUE', 0);
  end;
end;

procedure TMainForm.acFileSaveAsExecute(Sender: TObject);
var
  sNewFileName: String;
  bActiveProject: Boolean;
begin
  if ActiveMDIChild <> nil then begin
    bActiveProject := TMDIChild(ActiveMDIChild).FileName = m_sActiveProjectFile;
    sNewFileName := TMDIChild(ActiveMDIChild).SaveFileAs('');
    if bActiveProject then begin
      m_sActiveProjectFile := sNewFileName;
      UpdateProjectMenu;
    end else begin
      if IsExecutable(sNewFileName) then ChangeProject(sNewFileName);
    end;
  end;
end;

procedure TMainForm.acFileCloseExecute(Sender: TObject);
begin
  if ActiveMDIChild <> nil then ActiveMDIChild.Close;
end;



procedure TMainForm.tcFilesChange(Sender: TObject);
var
  mdi: TMDIChild;
begin
  if ([csDestroying] * ComponentState <> []) or m_bClosing then exit;
  SendMessage(ClientHandle, WM_MDIREFRESHMENU, 0, 0);
  if tcFiles.TabIndex > -1 then begin
    mdi := TMDIChild(tcFiles.Tabs.Objects[tcFiles.TabIndex]);
    if mdi <> nil then begin
//      ShowFile(mdi.FileName, -1, False, ExecutionState <> ecsDebug, mdi);
      ShowFile(mdi.FileName, -1, False,
        not (ExecutionState in [ecsDebug, ecsPendingCommand]), mdi);
    end;
  end;
end;

procedure TMainForm.HandleGoto(Sender: TObject; var sGoto: String);
var
  nLine: Integer;
  se: TSynEdit;
begin
  if ActiveMDIChild <> nil then begin
    se := TMDIChild(ActiveMDIChild).SynEdit;
    nLine := StrToIntDef(sGoto, -1);
    if (nLine > 0) and (nLine < se.Lines.Count) then begin
      se.CaretXY := Point(0, nLine);
      se.EnsureCursorPosVisible;
    end else begin
      Application.MessageBox(PChar('Line number must be between 1 and '
        + IntToStr(se.Lines.Count) + '.'), 'Open Perl IDE', MB_OK);
      sGoto := '1';
    end;
  end;
end;


function TMainForm.GetSearchAndReplaceOptions: TSynSearchOptions;
begin
  Result := [];
  if frWholeWord in ReplaceDialog.Options then Result := Result + [ssoWholeWord];
  if frMatchCase in ReplaceDialog.Options then Result := Result + [ssoMatchCase];
  if not (frDown in ReplaceDialog.Options) then Result := Result + [ssoBackwards];
  if frReplace in ReplaceDialog.Options then Result := Result + [ssoReplace];
  if frReplaceAll in ReplaceDialog.Options then Result := Result + [ssoReplaceAll];
end;


function TMainForm.GetFindOptions: TSynSearchOptions;
begin
  Result := [];
  if frWholeWord in FindDialog.Options then Result := Result + [ssoWholeWord];
  if frMatchCase in FindDialog.Options then Result := Result + [ssoMatchCase];
  if not (frDown in FindDialog.Options) then Result := Result + [ssoBackwards];
end;


procedure TMainForm.acFindExecute(Sender: TObject);
begin
  if ActiveMDIChild <> nil then begin
    if frmPreferences.chbFindTextAtCursor.Checked or (FindDialog.FindText = '')
      then FindDialog.FindText := TMDIChild(ActiveMDIChild).SelectedTextAtCursor;
    FindDialog.Execute;
  end;
end;

procedure TMainForm.acSearchAgainExecute(Sender: TObject);
begin
  if ActiveMDIChild <> nil then begin
    TMDIChild(ActiveMDIChild).SynEdit.SearchReplace(FindDialog.FindText, '', GetFindOptions);
  end;
end;

procedure TMainForm.FindDialogFind(Sender: TObject);
begin
  if ActiveMDIChild <> nil then begin
    TMDIChild(ActiveMDIChild).SynEdit.SearchReplace(FindDialog.FindText, '', GetFindOptions);
  end;
end;

procedure TMainForm.acReplaceExecute(Sender: TObject);
begin
  if ActiveMDIChild <> nil then begin
    if frmPreferences.chbFindTextAtCursor.Checked or (ReplaceDialog.FindText = '')
      then ReplaceDialog.FindText := TMDIChild(ActiveMDIChild).SelectedTextAtCursor;
    ReplaceDialog.Execute;
  end;
end;

procedure TMainForm.ReplaceDialogReplace(Sender: TObject);
begin
  if ActiveMDIChild <> nil then begin
    TMDIChild(ActiveMDIChild).SynEdit.SearchReplace(ReplaceDialog.FindText,
      ReplaceDialog.ReplaceText, GetSearchAndReplaceOptions);
  end;
end;

procedure TMainForm.acGoToLineNumberExecute(Sender: TObject);
begin
   if ActiveMDIChild <> nil then frmGoTo.Show;
end;

procedure TMainForm.acFileOpen2Execute(Sender: TObject);
begin
  acFileOpenExecute(nil);
end;

procedure TMainForm.acAboutExecute(Sender: TObject);
begin
  frmAbout.ShowModal;
end;

procedure TMainForm.Outputwindows1Click(Sender: TObject);
begin
  miConsole.Checked := frmConsole.Visible;
  miErrorOutput.Checked := frmError.Visible;
  miCommunicationLog.Checked := frmCommunicationLog.Visible;
end;

procedure TMainForm.acSaveAllExecute(Sender: TObject);
var
  i: Integer; 
begin
  for i := 0 to MDIChildCount - 1 do begin
    try
      with TMDIChild(MDIChildren[i]) do begin
        if HasChanged then SaveFile;
      end;
    except
      on E: Exception do
        MessageBox(Handle,
          PChar('Unable to save ' + TMDIChild(MDIChildren[i]).Filename),
          'Open Perl IDE', MB_OK);
    end;
  end;
end;

procedure TMainForm.acUndoExecute(Sender: TObject);
begin
  if ActiveMDIChild <> nil then begin
    TMDIChild(ActiveMDIChild).SynEdit.Undo;
    UpdateActions;
  end;
end;

procedure TMainForm.acRedoExecute(Sender: TObject);
begin
  if ActiveMDIChild <> nil then begin
    TMDIChild(ActiveMDIChild).SynEdit.Redo;
    UpdateActions;
  end;
end;

procedure TMainForm.acCloseAllExecute(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to MDIChildCount - 1 do MDIChildren[i].Close;
end;

procedure TMainForm.acHelpIndexExecute(Sender: TObject);
begin
  frmHelpIndex.ShowIndex;
end;

procedure TMainForm.acHelpContentsExecute(Sender: TObject);
begin
  frmHelpContents.ShowContent;
end;

procedure TMainForm.acHelpConfigurationExecute(Sender: TObject);
begin
  frmPreferences.pcPreferences.ActivePage := frmPreferences.tsHelp;
  frmPreferences.ShowModal;
end;

procedure TMainForm.acForceScriptTerminationExecute(Sender: TObject);
begin
  case ExecutionState of
    ecsRun: begin
      if m_clpPerl <> nil then begin
        TerminateProcess(m_clpPerl.ProcessHandle, 0);
        m_clpPerl.Free;
        m_clpPerl := nil;
      end;
    end;
    ecsPendingCommand, ecsCompile, ecsDebug: begin
      m_ReqProc.Dispatcher.ForceTermination;
    end;
  else
  end;
  ExecutionState := ecsNone;
end;

procedure TMainForm.acFilePrintPreviewExecute(Sender: TObject);
begin
  if ActiveMDIChild <> nil then begin
    TMDIChild(ActiveMDIChild).pnlPrintPreview.Visible := not TMDIChild(ActiveMDIChild).pnlPrintPreview.Visible;
    if TMDIChild(ActiveMDIChild).pnlPrintPreview.Visible then TMDIChild(ActiveMDIChild).PrintPreview;
  end;
end;

procedure TMainForm.acPrintExecute(Sender: TObject);
begin
  if ActiveMDIChild <> nil then TMDIChild(ActiveMDIChild).Print;
end;

procedure TMainForm.acFilePageSetupExecute(Sender: TObject);
begin
  PrinterSetupDialog.Execute;
end;

procedure TMainForm.splitTopCanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
begin
  Application.ShowHint := False;
end;

procedure TMainForm.splitTopMoved(Sender: TObject);
begin
  Application.ShowHint := True;
end;

procedure TMainForm.splitLeftCanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
begin
  Application.ShowHint := False;
end;

procedure TMainForm.splitLeftMoved(Sender: TObject);
begin
  Application.ShowHint := True;
end;

procedure TMainForm.splitBottomCanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
begin
  Application.ShowHint := False;
end;

procedure TMainForm.splitBottomMoved(Sender: TObject);
begin
  Application.ShowHint := True;
end;

procedure TMainForm.splitRightCanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
begin
 Application.ShowHint := False;
end;

procedure TMainForm.splitRightMoved(Sender: TObject);
begin
  Application.ShowHint := True;
end;

procedure TMainForm.timerRedrawHostingPageControlsTimer(Sender: TObject);
begin
  RedrawHostingPageControls;
  timerRedrawHostingPageControls.Enabled := False;
end;

procedure TMainForm.dpLeftDockOver(Sender: TObject;
  Source: TDragDockObject; X, Y: Integer; State: TDragState;
  var Accept: Boolean);
var
  rct: TRect;
begin
  if dpLeft.DockClientCount = 0 then begin
    rct.TopLeft := Point(0, dpLeft.Top);
    rct.BottomRight := Point(200, dpLeft.Top + dpLeft.Height);
    rct.TopLeft := ClientToScreen(rct.TopLeft);
    rct.BottomRight := ClientToScreen(rct.BottomRight);
    Source.DockRect := rct;
  end;
end;

procedure TMainForm.dpTopDockOver(Sender: TObject; Source: TDragDockObject;
  X, Y: Integer; State: TDragState; var Accept: Boolean);
var
  rct: TRect;
begin
  if dpTop.DockClientCount = 0 then begin
    rct.TopLeft := Point(0, dpTop.Top);
    rct.BottomRight := Point(dpTop.Width, dpTop.Top + 200);
    rct.TopLeft := ClientToScreen(rct.TopLeft);
    rct.BottomRight := ClientToScreen(rct.BottomRight);
    Source.DockRect := rct;
  end;
end;


procedure TMainForm.dpRightDockOver(Sender: TObject;
  Source: TDragDockObject; X, Y: Integer; State: TDragState;
  var Accept: Boolean);
var
  rct: TRect;
begin
  if dpRight.DockClientCount = 0 then begin
    rct.TopLeft := Point(dpRight.Left - 200, dpRight.Top);
    rct.BottomRight := Point(ClientWidth, dpRight.Top + dpRight.Height);
    rct.TopLeft := ClientToScreen(rct.TopLeft);
    rct.BottomRight := ClientToScreen(rct.BottomRight);
    Source.DockRect := rct;
  end;
end;

procedure TMainForm.dpBottomDockOver(Sender: TObject;
  Source: TDragDockObject; X, Y: Integer; State: TDragState;
  var Accept: Boolean);
var
  rct: TRect;
begin
  if dpBottom.DockClientCount = 0 then begin
    rct.TopLeft := Point(0, dpBottom.Top - 200);
    rct.BottomRight := Point(dpBottom.Width, ClientHeight);
    rct.TopLeft := ClientToScreen(rct.TopLeft);
    rct.BottomRight := ClientToScreen(rct.BottomRight);
    Source.DockRect := rct;
  end;
end;


procedure TMainForm.dpLeftResize(Sender: TObject);
begin
  if splitLeft.Visible
    then pnlTabsLeft.Width := dpLeft.Width + splitLeft.Width
    else pnlTabsLeft.Width := dpLeft.Width;
end;

procedure TMainForm.dpRightResize(Sender: TObject);
begin
  if splitRight.Visible
    then pnlTabsRight.Width := dpRight.Width + splitRight.Width
    else pnlTabsRight.Width := dpRight.Width;
end;


procedure TMainForm.HandleSetOtherHostsAsString(Sender: TDockHandler; sValue: String);
var
  i: Integer;
  sl: TStringList;
  sName: String;
  cmp: TComponent;
  frm: TDockableForm;
  mdi: TMDIChild;
begin
  sl := TStringList.Create;
  sl.CommaText := sValue;
  for i := 0 to sl.Count - 1 do begin
    sName := sl.Names[i];
    cmp := FindComponent(sl.Values[sName]);
    if cmp <> nil then begin
      if cmp is TDockableForm then begin
        frm := TDockableForm(cmp);
        mdi := CreateMDIChild('<' + frm.Caption + '>', False);
        frm.Tag := Integer(mdi);
        mdi.pnlChild.Visible := False;
        mdi.UseDockManager := True;
        mdi.DockSite := True;
        DockHandler.RegisterDockHost(mdi);
        frm.ManualDock(mdi);
        frm.Visible := True;
      end;
    end else if UpperCase(sName) = 'MAINFORM' then begin
      AsString := sl.Values[sName];
    end;
  end;
  sl.Free;
end;


function TMainForm.HandleGetOtherHostsAsString(Sender: TDockHandler): String;
var
  i: Integer;
  sl: TStringList;
  mdi: TMDIChild;
begin
  Result := '';
  sl := TStringList.Create;
  sl.Values['MainForm'] := AsString;
  for i := 0 to Sender.DockHostCount - 1 do begin
    if Sender.DockHosts[i] is TMDIChild then begin
      mdi := TMDIChild(Sender.DockHosts[i]);
      if mdi.DockClientCount = 1 then begin
        sl.Values[mdi.Name] := mdi.DockClients[0].Name;
      end;
    end;
  end;
  Result := sl.CommaText;
  sl.Free;
end;


procedure TMainForm.Helpwindows1Click(Sender: TObject);
begin
  miHelpContents.Checked := frmHelpContents.Visible;
  miHelpIndex.Checked := frmHelpIndex.Visible;
  miHelpViewer.Checked := frmHelp.Visible;
end;


procedure TMainForm.miCommunicationLogClick(Sender: TObject);
begin
  frmCommunicationLog.Visible := not frmCommunicationLog.Visible;
end;

procedure TMainForm.miHelpContentsClick(Sender: TObject);
begin
  if frmHelpContents.Visible then begin
    frmHelpContents.Visible := False;
  end else begin
    frmHelpContents.ShowContent;
  end;
end;

procedure TMainForm.miHelpIndexClick(Sender: TObject);
begin
  if frmHelpIndex.Visible then begin
    frmHelpIndex.Visible := False;
  end else begin
    frmHelpIndex.ShowIndex;
  end;
end;

procedure TMainForm.miHelpViewerClick(Sender: TObject);
begin
  frmHelp.Visible := not frmHelp.Visible;
end;

procedure TMainForm.cbxDesktopKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  idx: Integer;
begin
  if (Key = VK_DELETE) and (ssCtrl in Shift) then begin
    idx := cbxDesktop.Items.IndexOf(cbxDesktop.Text);
    if idx > -1 then begin
      if MessageBox(Handle, PChar('Delete desktop ' + cbxDesktop.Text + ' ?'),
        'Open Perl IDE', MB_OKCANCEL) = IDOK then begin
        ConfigStorage.WriteString('Desktops', cbxDesktop.Text, '');
        ConfigStorage.Flush;
        cbxDesktop.Items.Delete(idx);
        cbxDesktop.Text := '<deleted>';
      end;
//      cbxDesktop.SetFocus;
      Key := 0;
    end;
  end;
end;

procedure TMainForm.tmrHelpTimer(Sender: TObject);
var
  frm: TForm;
begin
  tmrHelp.Enabled := False;
  frm := ActiveMDIChild;
  if frmHelpContents.Visible then frmHelpContents.ShowContent;
  if frmHelpIndex.Visible then frmHelpIndex.ShowList;
  if (frm <> nil) and (frm <> ActiveMDIChild) then frm.BringToFront;
end;

initialization
  reg := TRegistry.Create;
  reg.RootKey := HKEY_LOCAL_MACHINE;
  if reg.OpenKey('\SOFTWARE\PERL\', False) then begin
    reg.RenameValue('PERL5DB', '__PERL5DB');
  end;
finalization
  if reg.OpenKey('\SOFTWARE\PERL\', False) then begin
    reg.RenameValue('__PERL5DB', 'PERL5DB');
  end;
  reg.Free;
end.

