{-------------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: f_About.pas, released 11 Mar 2001.

The Initial Developer of the Original Code is Jrgen Gntherodt.

Portions created by Jrgen Gntherodt <jguentherodt@users.sourceforge.net>
are Copyright (C) 2001-2002 Jrgen Gntherodt. All Rights Reserved.

Alternatively, the contents of this file may be used under the terms of the
GNU General Public License Version 2 or later (the "GPL"), in which case
the provisions of the GPL are applicable instead of those above.
If you wish to allow use of your version of this file only under the terms
of the GPL and not to allow others to use your version of this file
under the MPL, indicate your decision by deleting the provisions above and
replace them with the notice and other provisions required by the GPL.
If you do not delete the provisions above, a recipient may use your version
of this file under either the MPL or the GPL.

$Id: f_About.pas,v 1.4 2002/05/26 13:47:34 jguentherodt Exp $

You may retrieve the latest version of this file at the Open Perl IDE webpage,
located at http://open-perl-ide.sourceforge.net or http://www.lost-sunglasses.de
-------------------------------------------------------------------------------}
unit f_About;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, shellAPI, ComCtrls;

type
  TfrmAbout = class(TForm)
    pnlClient: TPanel;
    pnlRight: TPanel;
    btnOK: TButton;
    pcAbout: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    pnlThanksSynEdit: TPanel;
    lbSynEdit: TLabel;
    Label11: TLabel;
    pnlClientTop: TPanel;
    pnlCopyright: TPanel;
    Label8: TLabel;
    pnlThanksEldoS: TPanel;
    Label4: TLabel;
    lbEldos: TLabel;
    pnlSep1: TPanel;
    pnlThanks: TPanel;
    Label10: TLabel;
    Panel1: TPanel;
    Label2: TLabel;
    lbWebpageURL: TLabel;
    Label3: TLabel;
    Label6: TLabel;
    lbMozillaPublicLicense: TLabel;
    pnlDisclaimer: TPanel;
    Memo3: TMemo;
    Panel2: TPanel;
    pnlWarranty: TPanel;
    Memo2: TMemo;
    pnlSynEdit: TPanel;
    Memo1: TMemo;
    pnlEldos: TPanel;
    memoThanks: TMemo;
    pnlPerlIDE: TPanel;
    Memo4: TMemo;
    pnlClientTopTop: TPanel;
    Label1: TLabel;
    Label7: TLabel;
    lbWebpageURL2: TLabel;
    lbEmail: TLabel;
    Panel3: TPanel;
    Memo5: TMemo;
    Label5: TLabel;
    Label9: TLabel;
    Label13: TLabel;
    Panel4: TPanel;
    Panel5: TPanel;
    Label14: TLabel;
    Label15: TLabel;
    procedure lbMozillaPublicLicenseMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure lbEmailClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmAbout: TfrmAbout;

implementation

{$R *.DFM}

procedure TfrmAbout.lbMozillaPublicLicenseMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  with Sender as TLabel do begin
    if (x >= 0) and (x < ClientWidth) and (y >= 0) and (y < ClientHeight) then begin
      SetCaptureControl(Sender as TLabel);
      if Font.Color <> clBlue then begin
        Font.Style := [fsUnderline];
        Font.Color := clBlue;
      end;
    end else begin
      ReleaseCapture;
      if Font.Color <> clWindow then begin
        Font.Style := [];
        Font.Color := clWindowText;
      end;
    end;
  end;
end;

procedure TfrmAbout.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then Close;
end;



procedure TfrmAbout.lbEmailClick(Sender: TObject);
var
  s: String;
begin
  with Sender as TLabel do begin
    ReleaseCapture;
    if Font.Color <> clWindow then begin
      Font.Style := [];
      Font.Color := clWindowText;
    end;
    if copy(Caption, 1, 1) = '<' then begin
      s := 'mailto:' + copy(Caption, 2, Length(Caption) - 2);
    end else begin
      s := Caption;
    end;
    ShellExecute(0, 'open', PChar(s), nil, nil, 0);
  end;
end;

end.
