{-------------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.

The Initial Developer of the Original Code is Jrgen Gntherodt.

Portions created by Jrgen Gntherodt <jguentherodt@users.sourceforge.net>
are Copyright (C) 2001-2002 Jrgen Gntherodt. All Rights Reserved.

Alternatively, the contents of this file may be used under the terms of the
GNU General Public License Version 2 or later (the "GPL"), in which case
the provisions of the GPL are applicable instead of those above.
If you wish to allow use of your version of this file only under the terms
of the GPL and not to allow others to use your version of this file
under the MPL, indicate your decision by deleting the provisions above and
replace them with the notice and other provisions required by the GPL.
If you do not delete the provisions above, a recipient may use your version
of this file under either the MPL or the GPL.

$Id: f_Console.pas,v 1.3 2002/05/26 13:47:34 jguentherodt Exp $

You may retrieve the latest version of this file at the Open Perl IDE webpage,
located at http://open-perl-ide.sourceforge.net or http://www.lost-sunglasses.de
-------------------------------------------------------------------------------}
unit f_Console;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, message_interface, DockPanel;

type
  TfrmConsole = class(TDockableForm)
    pnlConsole: TPanel;
    memoConsole: TMemo;
    pnlParams: TPanel;
    pnlParamsLeft: TPanel;
    Label1: TLabel;
    pnlParamsClient: TPanel;
    edtParams: TEdit;
    Panel1: TPanel;
    procedure memoConsoleKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmConsole: TfrmConsole;

implementation

uses Main;

{$R *.DFM}

procedure TfrmConsole.memoConsoleKeyPress(Sender: TObject;
  var Key: Char);
var
  s: String;
  n: Integer;
begin
  if Key = #13 then begin
    n := SendMessage(memoConsole.Handle, EM_LINEFROMCHAR, -1, 0);
    s := memoConsole.Lines[n];
    MainForm.SendToStdIn(s + #13#10);
  end;
  if Key = #26 then begin
    // Send eof character
    MainForm.SendToStdIn(#26);
    Key := #0;
  end;
end;

procedure TfrmConsole.FormCreate(Sender: TObject);
begin
  edtParams.Align := alClient;
end;

end.
