{-------------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: f_ErrorOutput.pas, released 11 Mar 2001.

The Initial Developer of the Original Code is Jrgen Gntherodt.

Portions created by Jrgen Gntherodt <jguentherodt@users.sourceforge.net>
are Copyright (C) 2001-2002 Jrgen Gntherodt. All Rights Reserved.

Alternatively, the contents of this file may be used under the terms of the
GNU General Public License Version 2 or later (the "GPL"), in which case
the provisions of the GPL are applicable instead of those above.
If you wish to allow use of your version of this file only under the terms
of the GPL and not to allow others to use your version of this file
under the MPL, indicate your decision by deleting the provisions above and
replace them with the notice and other provisions required by the GPL.
If you do not delete the provisions above, a recipient may use your version
of this file under either the MPL or the GPL.

$Id: f_ErrorOutput.pas,v 1.6 2002/05/26 13:47:34 jguentherodt Exp $

You may retrieve the latest version of this file at the Open Perl IDE webpage,
located at http://open-perl-ide.sourceforge.net or http://www.lost-sunglasses.de
-------------------------------------------------------------------------------}
unit f_ErrorOutput;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, DockPanel;

type
  TfrmError = class(TDockableForm)
    pnlError: TPanel;
    Panel3: TPanel;
    memoErrorOutput: TMemo;
    procedure memoErrorOutputDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function ParseErrorLine(s: String; var sFileName: String; var nLine: Integer): Boolean;
  end;

var
  frmError: TfrmError;

implementation

uses Main;

{$R *.DFM}

function TfrmError.ParseErrorLine(s: String; var sFileName: String; var nLine: Integer): Boolean;
var
  sLineIndicator, sFileIndicator: String;
  nFileIndicator, nLineIndicator: Integer;
  nPos, code: Integer;
begin

  Result := False;
  if Pos('> DEBUG SESSION TERMINATED', UpperCase(s)) = 1 then exit;

  // Error analysis
  sFileIndicator := ' AT ';
  sLineIndicator := ' LINE ';
  nFileIndicator := Pos(sFileIndicator, UpperCase(s));
  nLineIndicator := Pos(sLineIndicator, UpperCase(s));
  // We assuming the following error message format:
  // * at <FileName> line <Line> .,

  if (nFileIndicator > 0) and (nLineIndicator > 0) then begin
    // error message from compiler
    s := copy(s, nFileIndicator + Length(sFileIndicator), Length(s));
    nPos := Pos(sLineIndicator, UpperCase(s));
    if nPos > 0 then begin
      sFileName := copy(s, 1, nPos - 1);
      s := copy(s, nPos + Length(sLineIndicator), Length(s));
      // Line number is terminated by "," or '.'
      nLine := -1;
      val(s, nLine, code);
      if code > 0 then begin
        s := copy(s, 1, code - 1);
        nLine := StrToIntDef(s, -1);
      end;
      Result := nLine > -1;
    end;
  end;
end;


procedure TfrmError.memoErrorOutputDblClick(Sender: TObject);
var
  s: String;
  n: Integer;
  sFileName: String;
  nLine: Integer;
begin
  n := SendMessage(memoErrorOutput.Handle, EM_LINEFROMCHAR, -1, 0);
  s := memoErrorOutput.Lines[n];
  if ParseErrorLine(s, sFileName, nLine) then MainForm.ShowError(sFileName, nLine);
end;

end.
